select min(length),
       max(length)
FROM
    (select array_length(p.path, 1) as length
     from documents_elementpath as p
     inner join
         (SELECT "documents_element"."id"
          FROM "documents_element"
          LEFT OUTER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
          WHERE ("documents_element"."corpus_id" = '{corpus_id}'::uuid
                 AND "documents_element"."worker_version_id" = '{version_id}'::uuid
                 AND ("documents_element"."id" = '{parent_id}'::uuid
                      OR "documents_elementpath"."path" && (ARRAY['{parent_id}'::uuid])::uuid[]))) as input on (array[input.id] && p.path)) as lengths ;

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT W0."id"
         FROM "documents_transcriptionentity" W0
         INNER JOIN "documents_transcription" W1 ON (W0."transcription_id" = W1."id")
         WHERE W1."element_id" IN
                 (SELECT V0."id"
                  FROM "documents_element" V0
                  INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
                  WHERE V1."path"[2] IN
                          (SELECT U0."id"
                           FROM "documents_element" U0
                           LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
                           WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                                  AND U0."worker_version_id" = '{version_id}'::uuid
                                  AND (U0."id" = '{parent_id}'::uuid
                                       OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[])))));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND U0."worker_version_id" = '{version_id}'::uuid
                         AND (U0."id" = '{parent_id}'::uuid
                              OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[]))));

DELETE
FROM "dataimport_workeractivity"
WHERE "dataimport_workeractivity"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND U0."worker_version_id" = '{version_id}'::uuid
                         AND (U0."id" = '{parent_id}'::uuid
                              OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[]))));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND U0."worker_version_id" = '{version_id}'::uuid
                         AND (U0."id" = '{parent_id}'::uuid
                              OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[]))));

DELETE
FROM "documents_classification"
WHERE "documents_classification"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND U0."worker_version_id" = '{version_id}'::uuid
                         AND (U0."id" = '{parent_id}'::uuid
                              OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[]))));

DELETE
FROM "documents_selection"
WHERE "documents_selection"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND U0."worker_version_id" = '{version_id}'::uuid
                         AND (U0."id" = '{parent_id}'::uuid
                              OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[]))));

DELETE
FROM "dataimport_dataimportelement"
WHERE "dataimport_dataimportelement"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND U0."worker_version_id" = '{version_id}'::uuid
                         AND (U0."id" = '{parent_id}'::uuid
                              OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[]))));

UPDATE "dataimport_dataimport"
SET "element_id" = NULL
WHERE "dataimport_dataimport"."element_id" IN
        (SELECT V0."id"
         FROM "documents_element" V0
         INNER JOIN "documents_elementpath" V1 ON (V0."id" = V1."element_id")
         WHERE V1."path"[2] IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND U0."worker_version_id" = '{version_id}'::uuid
                         AND (U0."id" = '{parent_id}'::uuid
                              OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[]))));

WITH element_ids (id) AS
    (DELETE
     FROM documents_elementpath
     WHERE element_id IN
             (SELECT "documents_element"."id"
              FROM "documents_element"
              INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
              WHERE "documents_elementpath"."path"[2] IN
                      (SELECT U0."id"
                       FROM "documents_element" U0
                       LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
                       WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                              AND U0."worker_version_id" = '{version_id}'::uuid
                              AND (U0."id" = '{parent_id}'::uuid
                                   OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[])))) RETURNING element_id)
DELETE
FROM documents_element element USING element_ids
WHERE element.id = element_ids.id ;

SELECT "documents_element"."id"
FROM "documents_element"
INNER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
WHERE "documents_elementpath"."path"[2] IN
        (SELECT U0."id"
         FROM "documents_element" U0
         LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."id" = '{parent_id}'::uuid
                     OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT V0."id"
         FROM "documents_transcriptionentity" V0
         INNER JOIN "documents_transcription" V1 ON (V0."transcription_id" = V1."id")
         WHERE V1."element_id" IN
                 (SELECT U0."id"
                  FROM "documents_element" U0
                  LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
                  WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                         AND U0."worker_version_id" = '{version_id}'::uuid
                         AND (U0."id" = '{parent_id}'::uuid
                              OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[]))));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."id" = '{parent_id}'::uuid
                     OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "dataimport_workeractivity"
WHERE "dataimport_workeractivity"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."id" = '{parent_id}'::uuid
                     OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."id" = '{parent_id}'::uuid
                     OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "documents_classification"
WHERE "documents_classification"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."id" = '{parent_id}'::uuid
                     OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "documents_selection"
WHERE "documents_selection"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."id" = '{parent_id}'::uuid
                     OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "dataimport_dataimportelement"
WHERE "dataimport_dataimportelement"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."id" = '{parent_id}'::uuid
                     OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

UPDATE "dataimport_dataimport"
SET "element_id" = NULL
WHERE "dataimport_dataimport"."element_id" IN
        (SELECT U0."id"
         FROM "documents_element" U0
         LEFT OUTER JOIN "documents_elementpath" U3 ON (U0."id" = U3."element_id")
         WHERE (U0."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."id" = '{parent_id}'::uuid
                     OR U3."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

WITH element_ids (id) AS
    (DELETE
     FROM documents_elementpath
     WHERE element_id IN
             (SELECT "documents_element"."id"
              FROM "documents_element"
              LEFT OUTER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
              WHERE ("documents_element"."corpus_id" = '{corpus_id}'::uuid
                     AND "documents_element"."worker_version_id" = '{version_id}'::uuid
                     AND ("documents_element"."id" = '{parent_id}'::uuid
                          OR "documents_elementpath"."path" && (ARRAY['{parent_id}'::uuid])::uuid[]))) RETURNING element_id)
DELETE
FROM documents_element element USING element_ids
WHERE element.id = element_ids.id ;

SELECT "documents_element"."id"
FROM "documents_element"
LEFT OUTER JOIN "documents_elementpath" ON ("documents_element"."id" = "documents_elementpath"."element_id")
WHERE ("documents_element"."corpus_id" = '{corpus_id}'::uuid
       AND "documents_element"."worker_version_id" = '{version_id}'::uuid
       AND ("documents_element"."id" = '{parent_id}'::uuid
            OR "documents_elementpath"."path" && (ARRAY['{parent_id}'::uuid])::uuid[]));

DELETE
FROM "documents_classification"
WHERE "documents_classification"."id" IN
        (SELECT U0."id"
         FROM "documents_classification" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         LEFT OUTER JOIN "documents_elementpath" U4 ON (U1."id" = U4."element_id")
         WHERE (U1."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."element_id" = '{parent_id}'::uuid
                     OR U4."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT U0."id"
         FROM "documents_transcriptionentity" U0
         INNER JOIN "documents_transcription" U1 ON (U0."transcription_id" = U1."id")
         INNER JOIN "documents_element" U2 ON (U1."element_id" = U2."id")
         LEFT OUTER JOIN "documents_elementpath" U5 ON (U2."id" = U5."element_id")
         WHERE (U2."corpus_id" = '{corpus_id}'::uuid
                AND U1."worker_version_id" = '{version_id}'::uuid
                AND (U1."element_id" = '{parent_id}'::uuid
                     OR U5."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "documents_transcriptionentity"
WHERE "documents_transcriptionentity"."id" IN
        (SELECT U0."id"
         FROM "documents_transcriptionentity" U0
         INNER JOIN "documents_transcription" U1 ON (U0."transcription_id" = U1."id")
         INNER JOIN "documents_element" U2 ON (U1."element_id" = U2."id")
         INNER JOIN "documents_entity" U4 ON (U0."entity_id" = U4."id")
         LEFT OUTER JOIN "documents_elementpath" U7 ON (U2."id" = U7."element_id")
         WHERE ((U2."corpus_id" = '{corpus_id}'::uuid
                 OR U4."corpus_id" = '{corpus_id}'::uuid)
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U1."element_id" = '{parent_id}'::uuid
                     OR U7."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "documents_transcription"
WHERE "documents_transcription"."id" IN
        (SELECT U0."id"
         FROM "documents_transcription" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         LEFT OUTER JOIN "documents_elementpath" U4 ON (U1."id" = U4."element_id")
         WHERE (U1."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."element_id" = '{parent_id}'::uuid
                     OR U4."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "documents_metadata"
WHERE "documents_metadata"."id" IN
        (SELECT U0."id"
         FROM "documents_metadata" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         LEFT OUTER JOIN "documents_elementpath" U4 ON (U1."id" = U4."element_id")
         WHERE (U1."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."element_id" = '{parent_id}'::uuid
                     OR U4."path" && (ARRAY['{parent_id}'::uuid])::uuid[])));

DELETE
FROM "dataimport_workeractivity"
WHERE "dataimport_workeractivity"."id" IN
        (SELECT U0."id"
         FROM "dataimport_workeractivity" U0
         INNER JOIN "documents_element" U1 ON (U0."element_id" = U1."id")
         LEFT OUTER JOIN "documents_elementpath" U4 ON (U1."id" = U4."element_id")
         WHERE (U1."corpus_id" = '{corpus_id}'::uuid
                AND U0."worker_version_id" = '{version_id}'::uuid
                AND (U0."element_id" = '{parent_id}'::uuid
                     OR U4."path" && (ARRAY['{parent_id}'::uuid])::uuid[])))
